//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
///-----------------------------------------------------------------
///
/// @file      Project2Dlg.cpp
/// @author    ghe3g
/// Created:   19.07.2012 10:12:26
/// @section   DESCRIPTION
///            Project2Dlg class implementation
///
///------------------------------------------------------------------

#include "Project2Dlg.h"
#include "getInput.h"
#include "genRaster.h"
#include "select_attribute_points.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/Project2Dlg_WxBitmapButtonFileOpenResult_XPM.xpm"
#include "E:/interpolation/prog/gui_test/test_dialog2/Images/Project2Dlg_WxBitmapButtonOpenInputFile_XPM.xpm"
////Header Include End

//----------------------------------------------------------------------------
// Project2Dlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(Project2Dlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(Project2Dlg::OnClose)
	EVT_BUTTON(ID_WXBITMAPBUTTONFILEOPENRESULT,Project2Dlg::WxBitmapButtonFileOpenResultClick)
	EVT_BUTTON(ID_WXBITMAPBUTTONOPENINPUTFILE,Project2Dlg::WxBitmapButtonOpenInputFileClick)
	EVT_BUTTON(ID_WXBUTTONRUN,Project2Dlg::WxButtonRunClick)
END_EVENT_TABLE()
////Event Table End

Project2Dlg::Project2Dlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

Project2Dlg::~Project2Dlg()
{
} 

void Project2Dlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	wxInitAllImageHandlers();   //Initialize graphic format handlers

	WxStaticTextAtlasBNA = new wxStaticText(this, ID_WXSTATICTEXTATLASBNA, _("(Atlas BNA)"), wxPoint(15, 28), wxDefaultSize, 0, _("WxStaticTextAtlasBNA"));

	WxStaticTextESRIGRID = new wxStaticText(this, ID_WXSTATICTEXTESRIGRID, _("(Surfer ASCII GRID)"), wxPoint(15, 350), wxDefaultSize, 0, _("WxStaticTextESRIGRID"));

	WxOpenFileDialogInputFile =  new wxFileDialog(this, _("Choose a file"), _(""), _(""), _("*.*"), wxFD_OPEN);

	WxOpenFileDialogResFile =  new wxFileDialog(this, _("Choose a file"), _(""), _(""), _("*.*"), wxFD_OPEN);

	wxBitmap WxBitmapButtonFileOpenResult_BITMAP (Project2Dlg_WxBitmapButtonFileOpenResult_XPM);
	WxBitmapButtonFileOpenResult = new wxBitmapButton(this, ID_WXBITMAPBUTTONFILEOPENRESULT, WxBitmapButtonFileOpenResult_BITMAP, wxPoint(410, 330), wxSize(30, 25), wxBU_AUTODRAW, wxDefaultValidator, _("WxBitmapButtonFileOpenResult"));

	wxBitmap WxBitmapButtonOpenInputFile_BITMAP (Project2Dlg_WxBitmapButtonOpenInputFile_XPM);
	WxBitmapButtonOpenInputFile = new wxBitmapButton(this, ID_WXBITMAPBUTTONOPENINPUTFILE, WxBitmapButtonOpenInputFile_BITMAP, wxPoint(410, 12), wxSize(30, 25), wxBU_AUTODRAW, wxDefaultValidator, _("WxBitmapButtonOpenInputFile"));

	WxEditResultFileName = new wxTextCtrl(this, ID_WXEDITRESULTFILENAME, _("c:\\*.*"), wxPoint(90, 330), wxSize(300, 22), 0, wxDefaultValidator, _("WxEditResultFileName"));

	WxEditInputFileName = new wxTextCtrl(this, ID_WXEDITINPUTFILENAME, _("c:\\*.*"), wxPoint(90, 12), wxSize(300, 22), 0, wxDefaultValidator, _("WxEditInputFileName"));

	WxGaugeCalculated = new wxGauge(this, ID_WXGAUGECALCULATED, 100, wxPoint(17, 416), wxSize(478, 28), wxGA_HORIZONTAL, wxDefaultValidator, _("WxGaugeCalculated"));
	WxGaugeCalculated->SetRange(100);
	WxGaugeCalculated->SetValue(0);

	WxButtonRun = new wxButton(this, ID_WXBUTTONRUN, _("Run"), wxPoint(183, 374), wxSize(104, 29), 0, wxDefaultValidator, _("WxButtonRun"));

	WxStaticTextResFile = new wxStaticText(this, ID_WXSTATICTEXTRESFILE, _("Result File:"), wxPoint(15, 330), wxDefaultSize, 0, _("WxStaticTextResFile"));

	WxEditRasWidth = new wxTextCtrl(this, ID_WXEDITRASWIDTH, _(""), wxPoint(250, 160), wxSize(60, 22), 0, wxDefaultValidator, _("WxEditRasWidth"));

	WxStaticTextDistRas = new wxStaticText(this, ID_WXSTATICTEXTDISTRAS, _("Raster Width:"), wxPoint(170, 165), wxDefaultSize, 0, _("WxStaticTextDistRas"));

	WxEditXMaxRas = new wxTextCtrl(this, ID_WXEDITXMAXRAS, _(""), wxPoint(350, 165), wxSize(125, 22), 0, wxDefaultValidator, _("WxEditXMaxRas"));

	WxStaticTextXMaxRas = new wxStaticText(this, ID_WXSTATICTEXTXMAXRAS, _("Max. X Coord. Raster:"), wxPoint(350, 145), wxDefaultSize, 0, _("WxStaticTextXMaxRas"));

	WxStaticTextXMax = new wxStaticText(this, ID_WXSTATICTEXTXMAX, _("xxxxxxx"), wxPoint(350, 125), wxDefaultSize, 0, _("WxStaticTextXMax"));

	WxStaticTextXMaxLine = new wxStaticText(this, ID_WXSTATICTEXTXMAXLINE, _("Max. X Coord. Lines:"), wxPoint(350, 110), wxDefaultSize, 0, _("WxStaticTextXMaxLine"));

	WxEditYMaxRas = new wxTextCtrl(this, ID_WXEDITYMAXRAS, _(""), wxPoint(180, 100), wxSize(125, 22), 0, wxDefaultValidator, _("WxEditYMaxRas"));

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, _("Max. Y Coord. Raster:"), wxPoint(180, 80), wxDefaultSize, 0, _("WxStaticText4"));

	WxStaticTextYMax = new wxStaticText(this, ID_WXSTATICTEXTYMAX, _("xxxxxxx"), wxPoint(180, 60), wxDefaultSize, 0, _("WxStaticTextYMax"));

	WxStaticTextYMaxLines = new wxStaticText(this, ID_WXSTATICTEXTYMAXLINES, _("Max. Y Coord. Lines:"), wxPoint(180, 45), wxDefaultSize, 0, _("WxStaticTextYMaxLines"));

	WxEditYMinRas = new wxTextCtrl(this, ID_WXEDITYMINRAS, _(""), wxPoint(180, 275), wxSize(125, 22), 0, wxDefaultValidator, _("WxEditYMinRas"));

	WxStaticTextYMinRas = new wxStaticText(this, ID_WXSTATICTEXTYMINRAS, _("Min. Y Coord. Raster:"), wxPoint(180, 255), wxDefaultSize, 0, _("WxStaticTextYMinRas"));

	WxStaticTextYMin = new wxStaticText(this, ID_WXSTATICTEXTYMIN, _("xxxxxxx"), wxPoint(180, 230), wxDefaultSize, 0, _("WxStaticTextYMin"));

	WxStaticTextYMinLine = new wxStaticText(this, ID_WXSTATICTEXTYMINLINE, _("Min. Y Coord. Lines:"), wxPoint(180, 215), wxDefaultSize, 0, _("WxStaticTextYMinLine"));

	WxStaticTextXMinRas = new wxStaticText(this, ID_WXSTATICTEXTXMINRAS, _("Min. X Coord. Raster:"), wxPoint(15, 145), wxDefaultSize, 0, _("WxStaticTextXMinRas"));

	WxStaticTextXMin = new wxStaticText(this, ID_WXSTATICTEXTXMIN, _("xxxxxxx"), wxPoint(15, 125), wxDefaultSize, 0, _("WxStaticTextXMin"));

	WxEditXMinRas = new wxTextCtrl(this, ID_WXEDITXMINRAS, _(""), wxPoint(15, 165), wxSize(125, 22), 0, wxDefaultValidator, _("WxEditXMinRas"));

	WxStaticTextXMinLine = new wxStaticText(this, ID_WXSTATICTEXTXMINLINE, _("Min. X Coord. Lines:"), wxPoint(15, 110), wxDefaultSize, 0, _("WxStaticTextXMinLine"));

	WxStaticTextOpenFile = new wxStaticText(this, ID_WXSTATICTEXTOPENFILE, _("Input File:"), wxPoint(18, 12), wxDefaultSize, 0, _("WxStaticTextOpenFile"));

	SetTitle(_("Project2"));
	SetIcon(wxNullIcon);
	SetSize(8,8,529,488);
	Center();
	
	////GUI Items Creation End
}

void Project2Dlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}


/*
 * WxBitmapButtonOpenInputFileClick
 */
void Project2Dlg::WxBitmapButtonOpenInputFileClick(wxCommandEvent& event)
{
	// insert your code here
	int pathInputFileOpen;
	number_of_points=0;
	
	pathInputFileOpen=WxOpenFileDialogInputFile->ShowModal();
	pathBNAInputFileName=WxOpenFileDialogInputFile->GetPath();
	WxEditInputFileName->SetValue(pathBNAInputFileName);
	setInputValues();
}

/*
 * WxBitmapButtonFileOpenResultClick
 */
void Project2Dlg::WxBitmapButtonFileOpenResultClick(wxCommandEvent& event)
{
	// insert your code here
	wxString pathESRIGRIDOutputFileName;
	int pathOutputFileOpen;
	pathOutputFileOpen=WxOpenFileDialogResFile->ShowModal();
	pathESRIGRIDOutputFileName=WxOpenFileDialogResFile->GetPath();
	WxEditResultFileName->SetValue(pathESRIGRIDOutputFileName);
}

void Project2Dlg::setInputValues()
{
    wxString tempString, wxstrXMinRas, wxstrYMinRas, wxstrXMaxRas, wxstrYMaxRas;
    dblMaxX=0; 
    dblMaxY=0; 
    dblMinX=0; 
    dblMinY=0;
    getLines inputLines;
	inputLines.setFile(pathBNAInputFileName);
	inputLines.getLinesFromFile();
	number_of_points = inputLines.getNumberPoints_bna();
	
	inputLines.analyze_file_content_bna();
	inputLines.findBoundaries();
	
	dblMaxX=inputLines.getMaxX();
    dblMaxY=inputLines.getMaxY();
    dblMinX=inputLines.getMinX();
    dblMinY=inputLines.getMinY();
    
    wxstrXMinRas<<dblMinX;
    WxStaticTextXMin->SetLabel(wxstrXMinRas);
    wxstrYMinRas<<dblMinY;
    WxStaticTextYMin->SetLabel(wxstrYMinRas);
    wxstrXMaxRas<<dblMaxX;
    WxStaticTextXMax->SetLabel(wxstrXMaxRas);
    wxstrYMaxRas<<dblMaxY;
    WxStaticTextYMax->SetLabel(wxstrYMaxRas);
    
    altis = inputLines.getNumberLines();
    alti_dist = inputLines.getAltiDistance();
    number_of_parts=inputLines.getNumberParts();
    
    alti_num = new long[number_of_parts];
    altitude= new double[number_of_parts];
    longitude_s= new double[number_of_parts]; 
    latitude_s= new double[number_of_parts];
    longitude_e= new double[number_of_parts];
    latitude_e= new double[number_of_parts];
    
    inputLines.set_short_Lines(alti_num, altitude, longitude_s, latitude_s, longitude_e, latitude_e);
}

/*
 * WxButtonRunClick
 */
void Project2Dlg::WxButtonRunClick(wxCommandEvent& event)
{
	// insert your code here
	wxString wxStrXMin, wxStrXMax, wxStrYMin, wxStrYMax, wxStrDist, wxTempString;
	
	wxStrXMin=WxEditXMinRas->GetValue();
	wxStrXMax=WxEditXMaxRas->GetValue();
	wxStrYMin=WxEditYMinRas->GetValue();
	wxStrYMax=WxEditYMaxRas->GetValue();
	wxStrDist=WxEditRasWidth->GetValue();
	pathEGOutputFileName=WxEditResultFileName->GetValue();
	
	double dblXMin, dblYMin, dblXMax, dblYMax, dblDist;
	
	if(!wxStrXMin.ToDouble(&dblXMin)){}
	if(!wxStrYMin.ToDouble(&dblYMin)){}
	if(!wxStrXMax.ToDouble(&dblXMax)){}
	if(!wxStrYMax.ToDouble(&dblYMax)){}
	if(!wxStrDist.ToDouble(&dblDist)){}
	
	generateRaster genRas;
	
	genRas.setXLL(dblXMin);
	genRas.setYLL(dblYMin);
	genRas.setXUR(dblXMax);
	genRas.setYUR(dblYMax);
	genRas.setDist(dblDist);
	
	num_ras_pnt = genRas.setDimensions(distance);
	
	raster_lon = new double[num_ras_pnt];
	raster_lat = new double[num_ras_pnt];
	raster_z = new double[num_ras_pnt];
	
	genRas.getRasterPoints(raster_lon, raster_lat, num_ras_pnt);
	
	sel_attrib_points calcRaster;
	calcRaster.setRaster(raster_lon, raster_lat, num_ras_pnt);
	calcRaster.setLineSegments(number_of_parts, alti_num, altitude, longitude_s, latitude_s, longitude_e, latitude_e, alti_dist);
	calcRaster.setBuffer(distance);
	
//	WxGaugeCalculated->SetRange(num_ras_pnt);
    wxString wxstrWorkingMessage;
    wxstrWorkingMessage<<"I'm working";
    wxMessageBox(wxstrWorkingMessage);
    
	calcRaster.select_and_set();
	
	//WxGaugeCalculated->Set
	//WxGaugeCalculated->SetValue
	
	wxString wxstrFinishedMessage;
    wxstrFinishedMessage<<"I'm working";
    wxMessageBox(wxstrFinishedMessage);
	calcRaster.setOutFileName(pathEGOutputFileName);
	calcRaster.getRaster();

}
