//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
// Class implementation for the generation of raster points. The corners and the distance
// will be given by the user either from a GIS or from an input-GUI


#include <iostream>
#include "genRaster.h"

using namespace std;

long generateRaster::setDimensions(double &dist)
{
 
 long number_raster_points;

 if (xll < xur)
 {
  x_lower_left = xll;
  x_upper_right = xur;
 }
 else
 {
     x_lower_left = xur;
     x_upper_right = xll;
 }
 
 if (yll < yur)
 {
  y_lower_left = yll;
  y_upper_right = yur;
 }
 
 else
 {
  y_lower_left = yur;
  y_upper_right = yll;
 }

//long number_x, number_y;
 
 number_x = (long)((x_upper_right - x_lower_left) / distance);
 number_y = (long)((y_upper_right - y_lower_left) / distance);
 
 number_raster_points = number_x * number_y;
 dist = distance;
 return number_raster_points;
 
}

void generateRaster::getRasterPoints(double longitude[], double latitude[], long number_raster_points)
{
 long counter1, counter2;
 
// longitude = new double[number_raster_points];
// latitude = new double[number_raster_points];
 
 for(counter1=0;counter1<number_y;counter1++)
 {
  for(counter2=0;counter2<number_x;counter2++)
  {
   longitude[counter2+counter1*number_x]=x_lower_left+counter2*distance;
   latitude[counter2+counter1*number_x]=y_lower_left+counter1*distance;
  }
 }
}

void generateRaster::setXLL(double dblXll)
{
    xll=dblXll;
}

void generateRaster::setYLL(double dblYll)
{
    yll=dblYll;
}

void generateRaster::setXUR(double dblXur)
{
    xur=dblXur;
}

void generateRaster::setYUR(double dblYur)
{
    yur=dblYur;
}

void generateRaster::setDist(double dblDist)
{
    distance=dblDist;
}
