//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
// Class to get the input lines


#include <iostream>
#include <string>
#include <wx/wx.h>

using namespace std;

class getLines
{
  public:
         getLines(){};
         ~getLines(){};
         void setFile(wxString wxStrInputFileName);
         void getLinesFromFile();
         void analyze_file_content();
         void analyze_file_content_bna();
         void set_short_Lines(long alti_num[], double altitude[], double longitude_s[], double latitude_s[], double longitude_e[], double latitude_e[]);
         long getNumberLines();
         long getNumberPoints_bna();
         long getNumberParts();
         long getNumberPoints();
         double getAltiDistance();
         void findBoundaries();
         double getMaxX();
         double getMinX();
         double getMaxY();
         double getMinY();
                  
  private: 
         //char *infile;  
         wxString infile;
         long num_lin;
         long num_parts;
         long num_points;
         long numLines_bna;
         double *x;
         double *y;
         double *z;
         long *lin_p;
         long *pnt_counter;
         double *alti_number;
         string file_content;
         double maxX;
         double maxY;
         double minX;
         double minY;
};
