//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//

#include "getInput.h"
#include "genRaster.h"
#include "select_attribute_points.h"

int main(void)
{
    long altis;
    long number_of_points;
    long number_of_parts;
    long counter1;
    double alti_dist;
    
    getLines inputLines;
    inputLines.setFile();
    inputLines.getLinesFromFile(); 
    number_of_points = inputLines.getNumberPoints_bna();
    inputLines.analyze_file_content_bna();
    altis = inputLines.getNumberLines();
    alti_dist = inputLines.getAltiDistance();
    number_of_parts=inputLines.getNumberParts();

    long *alti_num = new long[number_of_parts];
    double *altitude= new double[number_of_parts]; 
    double *longitude_s= new double[number_of_parts]; 
    double *latitude_s= new double[number_of_parts];
    double *longitude_e= new double[number_of_parts];
    double *latitude_e= new double[number_of_parts];

    inputLines.set_short_Lines(alti_num, altitude, longitude_s, latitude_s, longitude_e, latitude_e);

    generateRaster inputRaster;
    
    long num_ras_pnt;
    double distance;
    num_ras_pnt = inputRaster.setDimensions(distance);

    double *raster_lon = new double[num_ras_pnt];
    double *raster_lat = new double[num_ras_pnt];
    double *raster_z = new double[num_ras_pnt];
    
    inputRaster.getRasterPoints(raster_lon, raster_lat, num_ras_pnt);
    sel_attrib_points calcRaster;
    calcRaster.setRaster(raster_lon, raster_lat, num_ras_pnt);
    calcRaster.setLineSegments(number_of_parts, alti_num, altitude, longitude_s, latitude_s, longitude_e, latitude_e, alti_dist);
    calcRaster.setBuffer(distance);
    calcRaster.select_and_set();
    calcRaster.getRaster();
}
